jQuery(document).ready(function($){

	// Hide and show the Shortcode builder panel

	$('.' + nnr_rlp_shortcode.prefix + 'shortcode-builder').click(function(e){
		$('.' + nnr_rlp_shortcode.prefix + 'shortcode-builder-box').show();
		$('.' + nnr_rlp_shortcode.prefix + 'shortcode-builder-container').show();
		$('.' + nnr_rlp_shortcode.prefix + 'shortcode-builder-container').addClass('fade in');
		e.preventDefault();
	});

	$('.' + nnr_rlp_shortcode.prefix + 'shortcode-builder-close').click(function(e){
		$('.' + nnr_rlp_shortcode.prefix + 'shortcode-builder-box').hide();
		$('.' + nnr_rlp_shortcode.prefix + 'shortcode-builder-container').hide();
		$('.' + nnr_rlp_shortcode.prefix + 'shortcode-builder-container').removeClass('fade in');
		e.preventDefault();
	});

	$('.' + nnr_rlp_shortcode.prefix + 'shortcode-builder-add').click(function(e){
		e.preventDefault();
		wp.media.editor.insert($('.' + nnr_rlp_shortcode.prefix + 'shortcode').html());
		$('.' + nnr_rlp_shortcode.prefix + 'shortcode-builder-box').hide();
		$('.' + nnr_rlp_shortcode.prefix + 'shortcode-builder-container').hide();
		$('.' + nnr_rlp_shortcode.prefix + 'shortcode-builder-container').removeClass('fade in');

		// Increment the auto counter for the shortcode

		var data = {
			"action": "nnr_rlp_shortcode_increment",
		};

		$.post(nnr_rlp_shortcode.ajaxurl, data, function(response) {

			$('.nnr-rlp-id').attr('value', 'nnrobots_related_posts_' + response);

			var regex = new RegExp('(' + $('.nnr-rlp-id').data('shortcode') + '="(?:[^\\"]+|\\.)*")');

			var shortcode = $('.nnr-rlp-shortcode').html();

			if (shortcode.match(regex)) {
				shortcode = shortcode.replace(regex , $('.nnr-rlp-id').data('shortcode') + '="nnrobots_related_posts_' + response + '"');
			}

			$('.nnr-rlp-shortcode').html(shortcode);

		});

	});

	$('body').on('click', function(e){

		if ($('.' + nnr_rlp_shortcode.prefix + 'shortcode-builder-container').is(e.target)) {
			$('.' + nnr_rlp_shortcode.prefix + 'shortcode-builder-box').hide();
			$('.' + nnr_rlp_shortcode.prefix + 'shortcode-builder-container').hide();
			$('.' + nnr_rlp_shortcode.prefix + 'shortcode-builder-container').removeClass('fade in');
		}
	});

	// Creating the shortcode

	var shortcode = '[nnr_related_posts id=""]';

	$.each( $("." + nnr_rlp_shortcode.prefix + "shortcode-input"), function(key, value) {

		var regex = new RegExp('(' + $(this).data('shortcode') + '="(?:[^\\"]+|\\.)*")');

		var val = $(value).val();

		if ($(value).is(':checkbox')) {
			val = $(this).prop('checked');
		}

		if (shortcode.match(regex)) {
			shortcode = shortcode.replace(regex , $(value).data('shortcode') + '="' + val + '"');
		}

		$("." + nnr_rlp_shortcode.prefix + "shortcode").html(shortcode);

	});

	$("." + nnr_rlp_shortcode.prefix + "shortcode-input").keyup(function(){

		var regex = new RegExp('(' + $(this).data('shortcode') + '="(?:[^\\"]+|\\.)*")');

		var val = $(this).val();

		if (shortcode.match(regex)) {
			shortcode = shortcode.replace(regex, $(this).data('shortcode') + '="' + val + '"');
		} else {
			shortcode = shortcode.replace(']', ' ' + $(this).data('shortcode') + '="' + val + '"]');
		}

		$("." + nnr_rlp_shortcode.prefix + "shortcode").html(shortcode);

	}).change(function(){

		var regex = new RegExp('(' + $(this).data('shortcode') + '="(?:[^\\"]+|\\.)*")');

		var val = $(this).val();

		if ($(this).is(':checkbox')) {
			val = $(this).prop('checked');
		}

		if (shortcode.match(regex)) {
			shortcode = shortcode.replace(regex, $(this).data('shortcode') + '="' + val + '"');
		} else {
			shortcode = shortcode.replace(']', ' ' + $(this).data('shortcode') + '="' + val + '"]');
		}

		$("." + nnr_rlp_shortcode.prefix + "shortcode").html(shortcode);

	});

	// Hiding and showing settings

	$("." + nnr_rlp_shortcode.prefix + "color").hide();
	$("." + nnr_rlp_shortcode.prefix + "text-color").hide();
	$("." + nnr_rlp_shortcode.prefix + "post-meta").hide();
	$("." + nnr_rlp_shortcode.prefix + "views").hide();
	$("." + nnr_rlp_shortcode.prefix + "comments").hide();
	$("." + nnr_rlp_shortcode.prefix + "grid-size").hide();
	$("." + nnr_rlp_shortcode.prefix + "show-nav").hide();
	$("." + nnr_rlp_shortcode.prefix + "fancy-colors").hide();
	$("." + nnr_rlp_shortcode.prefix + "num-of-columns").hide();

	if ($("." + nnr_rlp_shortcode.prefix + "layout").val() == 'image_tile' ||
		$("." + nnr_rlp_shortcode.prefix + "layout").val() == 'colored_tabs' ||
		$("." + nnr_rlp_shortcode.prefix + "layout").val() == 'image_flip' ||
		$("." + nnr_rlp_shortcode.prefix + "layout").val() == 'inline_card' ||
		$("." + nnr_rlp_shortcode.prefix + "layout").val() == 'stacked_card') {

		$("." + nnr_rlp_shortcode.prefix + "color").show();
	}

	if ($("." + nnr_rlp_shortcode.prefix + "layout").val() != 'masonry' && $("." + nnr_rlp_shortcode.prefix + "layout").val() != 'grid') {
		$("." + nnr_rlp_shortcode.prefix + "post-meta").show();
		$("." + nnr_rlp_shortcode.prefix + "text-color").show();
		$("." + nnr_rlp_shortcode.prefix + "views").show();
		$("." + nnr_rlp_shortcode.prefix + "comments").show();
	}

	if ($("." + nnr_rlp_shortcode.prefix + "layout").val() == 'grid') {
		$("." + nnr_rlp_shortcode.prefix + "grid-size").show();
	}

	if ($("." + nnr_rlp_shortcode.prefix + "layout").val() == 'fancy_colors' ||
		$("." + nnr_rlp_shortcode.prefix + "layout").val() == 'colored_tabs') {
		$("." + nnr_rlp_shortcode.prefix + "fancy-colors").show();
	}

	if ($("." + nnr_rlp_shortcode.prefix + "layout").val() == 'slider') {
		$("." + nnr_rlp_shortcode.prefix + "show-nav").show();
	}

	if ($("." + nnr_rlp_shortcode.prefix + "layout").val() == 'stacked_card') {
		$("." + nnr_rlp_shortcode.prefix + "num-of-columns").show();
	}

	if ($("." + nnr_rlp_shortcode.prefix + "style-override").prop('checked')) {
		$("." + nnr_rlp_shortcode.prefix + "text-color").show();
	} else {
		$("." + nnr_rlp_shortcode.prefix + "text-color").hide();
	}

	$("." + nnr_rlp_shortcode.prefix + "style-override").change(function(){
		if ($(this).prop('checked')) {
			$("." + nnr_rlp_shortcode.prefix + "text-color").show();
		} else {
			$("." + nnr_rlp_shortcode.prefix + "text-color").hide();
		}
	});

	$("." + nnr_rlp_shortcode.prefix + "layout").change(function(){

		$("." + nnr_rlp_shortcode.prefix + "color").hide();
		$("." + nnr_rlp_shortcode.prefix + "post-meta").hide();
		$("." + nnr_rlp_shortcode.prefix + "views").hide();
		$("." + nnr_rlp_shortcode.prefix + "comments").hide();
		$("." + nnr_rlp_shortcode.prefix + "grid-size").hide();
		$("." + nnr_rlp_shortcode.prefix + "show-nav").hide();
		$("." + nnr_rlp_shortcode.prefix + "fancy-colors").hide();
		$("." + nnr_rlp_shortcode.prefix + "num-of-columns").hide();

		if ($(this).val() == 'image_tile' ||
			$(this).val() == 'colored_tabs' ||
			$(this).val() == 'image_flip' ||
			$(this).val() == 'inline_card' ||
			$(this).val() == 'stacked_card') {
			$("." + nnr_rlp_shortcode.prefix + "color").show();
		}

		if ($(this).val() != 'masonry' && $(this).val() != 'grid') {
			$("." + nnr_rlp_shortcode.prefix + "views").show();
			$("." + nnr_rlp_shortcode.prefix + "comments").show();
			$("." + nnr_rlp_shortcode.prefix + "post-meta").show();
			$("." + nnr_rlp_shortcode.prefix + "text-color").show();
		}

		if ($(this).val() == 'grid') {
			$("." + nnr_rlp_shortcode.prefix + "grid-size").show();
		}

		if ($(this).val() == 'fancy_colors' || $(this).val() == 'colored_tabs') {
			$("." + nnr_rlp_shortcode.prefix + "fancy-colors").show();
		}

		if ($(this).val() == 'slider') {
			$("." + nnr_rlp_shortcode.prefix + "show-nav").show();
		}

		if ($(this).val() == 'stacked_card') {
			$("." + nnr_rlp_shortcode.prefix + "num-of-columns").show();
		}

		if ($("." + nnr_rlp_shortcode.prefix + "style-override").prop('checked')) {
			$("." + nnr_rlp_shortcode.prefix + "text-color").show();
		} else {
			$("." + nnr_rlp_shortcode.prefix + "text-color").hide();
		}

	});

	$("." + nnr_rlp_shortcode.prefix + "category").hide();
	$("." + nnr_rlp_shortcode.prefix + "tag").hide();
	$("." + nnr_rlp_shortcode.prefix + "custom-post-type").hide();

	if ($("." + nnr_rlp_shortcode.prefix + "content").val() == 'category') {
		$("." + nnr_rlp_shortcode.prefix + "category").show();
	} else if ($("." + nnr_rlp_shortcode.prefix + "content").val() == 'tag') {
		$("." + nnr_rlp_shortcode.prefix + "tag").show();
	} else if ($("." + nnr_rlp_shortcode.prefix + "content").val() == 'custom_post_type') {
		$("." + nnr_rlp_shortcode.prefix + "custom-post-type").show();
	}

	$("." + nnr_rlp_shortcode.prefix + "content").change(function(){
		$("." + nnr_rlp_shortcode.prefix + "category").hide();
		$("." + nnr_rlp_shortcode.prefix + "tag").hide();
		$("." + nnr_rlp_shortcode.prefix + "custom-post-type").hide();

		if ($(this).val() == 'category') {
			$("." + nnr_rlp_shortcode.prefix + "category").show();
		} else if ($(this).val() == 'tag') {
			$("." + nnr_rlp_shortcode.prefix + "tag").show();
		} else if ($(this).val() == 'custom_post_type') {
			$("." + nnr_rlp_shortcode.prefix + "custom-post-type").show();
		}
	});

	// Background Color Picker

	$('.bg-color-picker').wpColorPicker({
        defaultColor: '#1e73be',
        change: function() {
	    	nnr_rlp_shortcode_color_picker($(this));
	    }
    });

	// Text Color Picker

	$('.color-picker').wpColorPicker({
        defaultColor: '#000000',
        change: function() {
	    	nnr_rlp_shortcode_color_picker($(this));
	    }
    });

	// Numbered List Color Picker

	$('.nl-color-picker').wpColorPicker({
        defaultColor: '#ffffff',
        change: function() {
	    	nnr_rlp_shortcode_color_picker($(this));
	    }
    });

	// Numbered List Box Color Picker

	$('.nl-circle-color-picker').wpColorPicker({
        defaultColor: '#94cd4b',
        change: function() {
	    	nnr_rlp_shortcode_color_picker($(this));
	    }
    });

    /**
     * Registers a change event for the color picker to update the shortcode
     *
     * @access public
     * @param mixed colorpicker
     * @return void
     */
    function nnr_rlp_shortcode_color_picker( colorpicker ) {

	    var regex = new RegExp('(' + $(colorpicker).data('shortcode') + '="(?:[^\\"]+|\\.)*")');

		var val = $(colorpicker).wpColorPicker('color');

		if (shortcode.match(regex)) {
			shortcode = shortcode.replace(regex, $(colorpicker).data('shortcode') + '="' + val + '"');
		} else {
			shortcode = shortcode.replace(']', ' ' + $(colorpicker).data('shortcode') + '="' + val + '"]');
		}

		$("." + nnr_rlp_shortcode.prefix + "shortcode").html(shortcode);
    }

	// Fancy Color Picker

	$.each($("input." + nnr_rlp_shortcode.prefix + "fancy-colors-selectize"), function(key, value){

		$('input.' + nnr_rlp_shortcode.prefix + 'fancy-colors-selectize.selectized').hide();

		if (!$(value).hasClass('selectized')) {
			$(value).selectize({
				plugins: ['drag_drop', 'remove_button'],
				valueField: 'hex',
			    labelField: 'name',
			    searchField: 'name',
			    options: [
			       	{hex: '#61BD6D', name: 'Fern'},
			        {hex: '#1ABC9C', name: 'Mountain Meadow'},
			        {hex: '#54ACD2', name: 'Picton Blue'},
			        {hex: '#2C82C9', name: 'Mariner'},
			        {hex: '#9365B8', name: 'Wisteria'},
			        {hex: '#457757', name: 'Chambray'},
			        {hex: '#41A85F', name: 'Chateau Green'},
			        {hex: '#00A885', name: 'Persian Green'},
			        {hex: '#3D8EB9', name: 'Curious Blue'},
			        {hex: '#2969B0', name: 'Denim'},
			        {hex: '#553982', name: 'Blue Gem'},
			        {hex: '#28324E', name: 'Blue Whale'},
			        {hex: '#F7DA64', name: 'Energy'},
			        {hex: '#FBA026', name: 'Neon Carrot'},
			        {hex: '#EB6B56', name: 'Terra Cotta'},
			        {hex: '#E14938', name: 'Cinnabar'},
			        {hex: '#A38F84', name: 'Almond Frost'},
			        {hex: '#EFEFEF', name: 'White Smoke'},
			        {hex: '#FAC51C', name: 'Turbo'},
			        {hex: '#F37934', name: 'Sun'},
			        {hex: '#D14841', name: 'Valencia'},
			        {hex: '#B8312F', name: 'Well Road'},
			        {hex: '#75706B', name: 'Iron Gray'},
			        {hex: '#D1D5D8', name: 'Iron'},
				],
			    onChange: function(){
				    $.each($(".selectize-input .item"), function(key, value){
						$(value).css('background-color', $(value).data('value'));

						if ($(value).data('value') == '#457757' ||
							$(value).data('value') == '#2969B0' ||
							$(value).data('value') == '#553982' ||
							$(value).data('value') == '#28324E' ||
							$(value).data('value') == '#75706B') {
							$(value).css('color', 'white');
						}
					});
			    },
			    render: {
				    option: function(data, escape) {

					    if (data.hex == '#457757' ||
							data.hex == '#2969B0' ||
							data.hex == '#553982' ||
							data.hex == '#28324E' ||
							data.hex == '#75706B') {
							return '<div class="option" style="background-color:' + data.hex + ';color:#ffffff;">' + escape(data.name) + '</div>';
						}

					    return '<div class="option" style="background-color:' + data.hex + ';">' + escape(data.name) + '</div>';
				    },
				    item : function(data, escape) {

					    if (data.hex == '#457757' ||
							data.hex == '#2969B0' ||
							data.hex == '#553982' ||
							data.hex == '#28324E' ||
							data.hex == '#75706B') {
							return '<div class="item" style="background-color:' + data.hex + ';color:#ffffff;">' + escape(data.name) + '</div>';
						}

					    return '<div class="item" style="background-color:' + data.hex + ';">' + escape(data.name) + '</div>';
				    }
			    }
			});
		}
	});
});